'==============
'PianoSimon.bas v1.1
'==============
'Coded by Dav to fight boredom.
'This was made using QB64/2011.

'PianoSimon is a simple Simon type game.
'Can also just play piano in free play mode.
'Requires .JPG & .WAV data in a \data\ folder!

'HOW TO PLAY
'===========

'Listen to the melody and try to play it back.
'If you do then you win, if not then you lose.

'You can change the length of the song by changing
'the "song" variable in the code below.

'FREE PLAY MODE
'==============

'Toggle free play mode by pressing the F
'While in free play mode you can just play the piano,
'without being in a memory game. Press F again to
'go back to the memory game mode.

'Press H to get a help screen.


DEFINT A-Z
DECLARE SUB PlayNote (thenote$)
DIM SHARED oo&, c1&, d1&, e1&, f1&, g1&, a1&, b1&, c2&


'==== Set screen, load bmps.
scrn& = _NEWIMAGE(640, 480, 32)
SCREEN scrn&

oo& = _LOADIMAGE("data\_00.jpg"):
c1& = _LOADIMAGE("data\_c1.jpg"):
d1& = _LOADIMAGE("data\_d1.jpg"):
e1& = _LOADIMAGE("data\_e1.jpg"):
f1& = _LOADIMAGE("data\_f1.jpg"):
g1& = _LOADIMAGE("data\_g1.jpg"):
a1& = _LOADIMAGE("data\_a1.jpg"):
b1& = _LOADIMAGE("data\_b1.jpg"):
c2& = _LOADIMAGE("data\_c2.jpg"):

_FULLSCREEN
_MOUSESHOW


'==== Give screen time to go into resolution.

_DELAY 1

'==== Build winner & loser songs

winner$ = "C1D1E1F1G1A1B1C2"
loser$ = "B1F1B1F1B1F1B1F1"

'=== default to memory game (no free play)

freeplay = 0

NewGame:

'==== How many notes in a song
'==== CHANGE IT make a song longer

song = 10

IF freeplay = 0 THEN

    CLS: LOCATE 12, 30
    PRINT "Generating song..."

    '==== Generate random notes for song

    RANDOMIZE TIMER
    notes$ = ""
    FOR t = 1 TO song
        n = INT((RND * 8) + 1)
        SELECT CASE n
            CASE IS = 1: notes$ = notes$ + "C1"
            CASE IS = 2: notes$ = notes$ + "D1"
            CASE IS = 3: notes$ = notes$ + "E1"
            CASE IS = 4: notes$ = notes$ + "F1"
            CASE IS = 5: notes$ = notes$ + "G1"
            CASE IS = 6: notes$ = notes$ + "A1"
            CASE IS = 7: notes$ = notes$ + "B1"
            CASE IS = 8: notes$ = notes$ + "C2"
        END SELECT
    NEXT

    '=== Give people time to prepare..
    '=== (creates a little suspense too)
    _DELAY 2

    '==== Show piano keyboard.
    PlayNote "00"
    LOCATE 12, 35: PRINT "Get ready..."
    _DELAY 2

ELSE
    CLS: LOCATE 12, 30
    PRINT "Free Play mode..."
    _DELAY 2

    '==== Show piano keyboard.
    PlayNote "00"

END IF


'==== Play song, one note at a time...

stopnote = 1

repeatsong:

DO

    IF freeplay = 0 THEN
        FOR t = 1 TO stopnote
            note$ = MID$(notes$, t, 2)
            PlayNote note$
            _DELAY .25
            PlayNote "00"
            _DELAY .1
        NEXT

        _DELAY .4
    END IF

    '==== Get users input...
    '====  Wait until mouse button is not pressed...
    DO: trap& = _MOUSEINPUT
    LOOP UNTIL NOT _MOUSEBUTTON(1)

    a$ = ""
    DO
        cheese& = _MOUSEINPUT
        IF _MOUSEBUTTON(1) THEN
            IF _MOUSEX > 115 AND _MOUSEX < 156 AND _MOUSEY > 342 AND _MOUSEY < 455 THEN
                PlayNote "C1"
                a$ = a$ + "C1"
            END IF
            IF _MOUSEX > 166 AND _MOUSEX < 212 AND _MOUSEY > 342 AND _MOUSEY < 455 THEN
                PlayNote "D1"
                a$ = a$ + "D1"
            END IF
            IF _MOUSEX > 219 AND _MOUSEX < 269 AND _MOUSEY > 342 AND _MOUSEY < 455 THEN
                PlayNote "E1"
                a$ = a$ + "E1"
            END IF
            IF _MOUSEX > 275 AND _MOUSEX < 326 AND _MOUSEY > 342 AND _MOUSEY < 455 THEN
                PlayNote "F1"
                a$ = a$ + "F1"
            END IF
            IF _MOUSEX > 331 AND _MOUSEX < 383 AND _MOUSEY > 342 AND _MOUSEY < 455 THEN
                PlayNote "G1"
                a$ = a$ + "G1"
            END IF
            IF _MOUSEX > 388 AND _MOUSEX < 440 AND _MOUSEY > 342 AND _MOUSEY < 455 THEN
                PlayNote "A1"
                a$ = a$ + "A1"
            END IF
            IF _MOUSEX > 447 AND _MOUSEX < 490 AND _MOUSEY > 342 AND _MOUSEY < 455 THEN
                PlayNote "B1"
                a$ = a$ + "B1"
            END IF
            IF _MOUSEX > 500 AND _MOUSEX < 542 AND _MOUSEY > 342 AND _MOUSEY < 455 THEN
                PlayNote "C2"
                a$ = a$ + "C2"
            END IF

            _DELAY .4

            PlayNote "00"

            '=== Make sure mouse button NOT pressed any more...
            DO: trap& = _MOUSEINPUT
            LOOP UNTIL NOT _MOUSEBUTTON(1)

        END IF
        IF freeplay = 0 THEN
            'check if users input is same as notes$.
            IF a$ <> MID$(notes$, 1, LEN(a$)) THEN

                FOR t = 1 TO LEN(loser$) STEP 2
                    PlayNote MID$(loser$, t, 2)
                    LOCATE 12, 30: PRINT "WRONG NOTE!  YOU LOSE!"
                    LOCATE 14, 30: PRINT "YOU GOT "; LEN(a$) / 2 - 1; " OUT OF "; song
                    _DELAY .2
                NEXT
                _DELAY 2
                GOTO NewGame

            END IF
        END IF

        SELECT CASE UCASE$(INKEY$)
            CASE IS = CHR$(27): GOTO EndGame
            CASE IS = "F"
                IF freeplay = 0 THEN
                    freeplay = 1
                ELSE
                    freeplay = 0
                END IF
                GOTO NewGame
            CASE IS = "H"
                CLS
                LOCATE 3, 33: PRINT "PIANO SIMON"
                LOCATE 5, 5: PRINT "HOW TO PLAY:"
                LOCATE 7, 17: PRINT "Use the mouse to playback the notes the computer plays."
                LOCATE 8, 17: PRINT "The computer will play one note, you repeat it. Then it"
                LOCATE 9, 17: PRINT "will play two notes, you repeat, and so on.  If you can"
                LOCATE 10, 17: PRINT "play all notes in the computers song, then you win!"
                LOCATE 13, 7: PRINT "CONTROLS:"
                LOCATE 15, 17: PRINT "N = New Game"
                LOCATE 17, 17: PRINT "R = Repeat Song playback"
                LOCATE 19, 17: PRINT "F = Toggle free play On/Off"
                LOCATE 21, 17: PRINT "ESC = Quit Piano Simon"
                LOCATE 28, 26: PRINT "PRESS ANY KEY TO CONTINUE"
                SLEEP: DO: LOOP UNTIL INKEY$ = ""
                PlayNote "00"
            CASE IS = "N"
                freeplay = 0: GOTO NewGame
            CASE IS = "R"
                IF freeplay = 0 THEN
                    a$ = "": GOTO repeatsong
                END IF
        END SELECT

    LOOP UNTIL LEN(a$) > stopnote

    IF freeplay = 0 THEN
        _DELAY .6

        '=== move note counter, if that was the end, we have WINNER!
        stopnote = stopnote + 2
        IF stopnote > LEN(notes$) THEN

            FOR t = 1 TO LEN(winner$) STEP 2
                PlayNote MID$(winner$, t, 2)
                LOCATE 12, 35: PRINT "YOU DID IT!"
                _DELAY .2
            NEXT
            _DELAY 2
            GOTO NewGame

        END IF
    END IF

LOOP UNTIL INKEY$ = CHR$(27)

EndGame:

_FREEIMAGE (oo&)
_FREEIMAGE (c1&)
_FREEIMAGE (d1&)
_FREEIMAGE (e1&)
_FREEIMAGE (f1&)
_FREEIMAGE (g1&)
_FREEIMAGE (a1&)
_FREEIMAGE (b1&)
_FREEIMAGE (c2&)

SYSTEM


'===================================================================================
SUB PlayNote (thenote$)
SELECT CASE thenote$
    CASE "00": _PUTIMAGE , oo&
    CASE "C1": _PUTIMAGE , c1&: _SNDPLAYFILE "data\c1.wav"
    CASE "D1": _PUTIMAGE , d1&: _SNDPLAYFILE "data\d1.wav"
    CASE "E1": _PUTIMAGE , e1&: _SNDPLAYFILE "data\e1.wav"
    CASE "F1": _PUTIMAGE , f1&: _SNDPLAYFILE "data\f1.wav"
    CASE "G1": _PUTIMAGE , g1&: _SNDPLAYFILE "data\g1.wav"
    CASE "A1": _PUTIMAGE , a1&: _SNDPLAYFILE "data\a1.wav"
    CASE "B1": _PUTIMAGE , b1&: _SNDPLAYFILE "data\b1.wav"
    CASE "C2": _PUTIMAGE , c2&: _SNDPLAYFILE "data\c2.wav"
END SELECT
LOCATE 1, 68: PRINT "H = Help"
END SUB
